diff --git i/src/Makefile w/src/Makefile
index 0d4a6ee..2a5330a 100644
--- i/src/Makefile
+++ w/src/Makefile
@@ -28,6 +28,13 @@ SUBDIRS = \
 
 $(recurse)
 
+# On platforms that require the backend to be built before dynamically
+# loadable modules, partially constraint the build order for more
+# efficient and robust builds.
+ifdef BE_DLLLIBS
+all-backend/utils/mb/conversion_procs-recurse all-backend/replication/libpqwalreceiver-recurse all-pl-recurse: all-backend-recurse
+endif
+
 install: install-local
 
 install-local: installdirs-local
